// CPLD Interface for SelectMAP Configuration (VIRTEX) from Parallel EPROM.
// Designer: Carl Carmichael
// Company: XILINX, Inc.
// Date: Jan 20, 1999.
// module: prom_map.
// components: OBUFT.
// Implementation: XC9536-VQ44

module prom_map(ADDR, CS, WRITE, BUSY, INIT, PROG, DONE, CCLK);

output [19:0] ADDR;
output CS, WRITE;
input BUSY, INIT, PROG, DONE, CCLK;

reg [19:0] address;
reg control;

wire  write_strobe, chip_select;

// Instantiate OBUFT.
OBUFT u0 (.O(ADDR[0]), .T(DONE), .I(address[0]));

// Instantiate OBUFT.
OBUFT u1 (.O(ADDR[1]), .T(DONE), .I(address[1]));

// Instantiate OBUFT.
OBUFT u2 (.O(ADDR[2]), .T(DONE), .I(address[2]));

// Instantiate OBUFT.
OBUFT u3 (.O(ADDR[3]), .T(DONE), .I(address[3]));

// Instantiate OBUFT.
OBUFT u4 (.O(ADDR[4]), .T(DONE), .I(address[4]));

// Instantiate OBUFT.
OBUFT u5 (.O(ADDR[5]), .T(DONE), .I(address[5]));

// Instantiate OBUFT.
OBUFT u6 (.O(ADDR[6]), .T(DONE), .I(address[6]));

// Instantiate OBUFT.
OBUFT u7 (.O(ADDR[7]), .T(DONE), .I(address[7]));

// Instantiate OBUFT.
OBUFT u8 (.O(ADDR[8]), .T(DONE), .I(address[8]));

// Instantiate OBUFT.
OBUFT u9 (.O(ADDR[9]), .T(DONE), .I(address[9]));

// Instantiate OBUFT.
OBUFT u10 (.O(ADDR[10]), .T(DONE), .I(address[10]));

// Instantiate OBUFT.
OBUFT u11 (.O(ADDR[11]), .T(DONE), .I(address[11]));

// Instantiate OBUFT.
OBUFT u12 (.O(ADDR[12]), .T(DONE), .I(address[12]));

// Instantiate OBUFT.
OBUFT u13 (.O(ADDR[13]), .T(DONE), .I(address[13]));

// Instantiate OBUFT.
OBUFT u14 (.O(ADDR[14]), .T(DONE), .I(address[14]));

// Instantiate OBUFT.
OBUFT u15 (.O(ADDR[15]), .T(DONE), .I(address[15]));

// Instantiate OBUFT.
OBUFT u16 (.O(ADDR[16]), .T(DONE), .I(address[16]));

// Instantiate OBUFT.
OBUFT u17 (.O(ADDR[17]), .T(DONE), .I(address[17]));

// Instantiate OBUFT.
OBUFT u18 (.O(ADDR[18]), .T(DONE), .I(address[18]));

// Instantiate OBUFT.
OBUFT u19 (.O(ADDR[19]), .T(DONE), .I(address[19]));

// Instantiate OBUFT.
OBUFT u20 (.O(CS), .T(DONE), .I(chip_select));

// Instantiate OBUFT.
OBUFT u21 (.O(WRITE), .T(DONE), .I(write_strobe));


always @(posedge CCLK or negedge PROG)
begin
   if (~PROG)
      begin
	control = 1'b0;
      end
   else
      begin
	control = INIT;
      end
end

always @(posedge CCLK or negedge PROG)
begin
   if (~PROG)
      begin
	address = 20'h00000;
      end
   else
      begin
	if (INIT & ~BUSY & control)
	   begin
		address = address + 20'h00001;
	   end
	else
	   begin
		address = address;
	   end
      end
end

assign write_strobe = ~control;
assign chip_select = ~control;

endmodule
